function i=myf(xyz,nf)
  x=xyz(1); y=xyz(2); z=xyz(3);
  i=[sin(x^2)+sin(y^2)+sin(z^2)
  2^sin(x)+3^cos(y)+4^sin(z)
  2^log(x^2+y^2+z^2+0.00001)
  sin(x^2-y^2-z^2)
  cos(x^2+y^2+z^2) 
  sin(x^2+y^2+z^2)]
endfunction

function [X,Y,Z]=cube2tetrahedrons()
//given a cube defined by 
// -1<=x<=1
// -1<=y<=1 
// -1<=z<=1 
// this function gives a 12 tetrahedrons decomposition of the cube volume
// X(:,i),Y(:,i),Z(:,i) are the coordinates of the ith  tetrahedron edges
//bottom tetra's
  X1=[0;-1; 1; 1];
  Y1=[0;-1;-1; 1];
  Z1=[0;-1;-1;-1];
 
  X2=[0;-1;-1; 1];
  Y2=[0;-1; 1; 1];
  Z2=[0;-1;-1;-1];
//top tetra's
  X3= X1
  Y3= Y1
  Z3=-Z1
 
  X4= X2
  Y4= Y2
  Z4=-Z2
//right tetra's
  X5=[0; 1; 1; 1];
  Y5=[0;-1; 1;-1];
  Z5=[0;-1;-1; 1];
 
  X6=[0; 1; 1; 1];
  Y6=[0; 1; 1;-1];
  Z6=[0; 1;-1;-1];
//left tetra's
  X7=-X5
  Y7= Y5
  Z7= Z5
 
  X8=-X6
  Y8= Y6
  Z8= Z6
//front tetra's
  X9=[0;-1; 1; 1];
  Y9=[0;-1;-1;-1];
  Z9=[0;-1;-1; 1];
 
  X10=[0;-1;-1; 1];
  Y10=[0;-1;-1;-1];
  Z10=[0;-1; 1; 1];
//rear tetra's
  X11= X9
  Y11=-Y9
  Z11= Z9
  
  X12= X10
  Y12=-Y10
  Z12= Z10

  X=[X1 X2 X3 X4 X5 X6 X7 X8 X9 X10 X11 X12]
  Y=[Y1 Y2 Y3 Y4 Y5 Y6 Y7 Y8 Y9 Y10 Y11 Y12]
  Z=[Z1 Z2 Z3 Z4 Z5 Z6 Z7 Z8 Z9 Z10 Z11 Z12]
endfunction



stacksize(80000000)

disp('The following benchmark program will print the average timings');
disp('to calculate the functions by 3 runs.');
disp(' ');
disp(' ');
disp('!!! SCILAB - Benchmarkprogram !!!');
disp('=================================');
disp(' ');
 
//* Test of IO function - Reading of data from file (either ODBC or flat file) *

result = 0;
a = 0;
b = 0;
runs = 3;
for i=1:runs
   timer();
   [fd,err]=mopen('E:\Mathematik\Ncrunch4\currency2.txt','r',1);
   header=mgetstr(154,fd);
   datmat=fscanfMat('E:\Mathematik\Ncrunch4\currency2.txt');
   zeit=timer();
   result=result+zeit;
end
result=result/runs;
disp('IO test_____________________________________________: '+string(result)+' sec.');

//* Test of Extraction of submatrices and calculation of descriptive stats */
//* Doing the whole process 100 times do get higher timings                */

result=0;
LimitsArea={1,261,522,784,1045,1305,1565,1827,2088,2349,2610,2871,3131,3158};
for i=1:runs
  timer();
  for k=1:100
    for j=1:13
      Year_Data=datmat(LimitsArea(j):LimitsArea(j+1)-1,5:38);
      Min_Year=min(Year_Data,1);
      Max_Year=max(Year_Data,1);
      Mean_Year=mean(Year_Data,1);
      GainLoss_Year=100-(Year_Data(1,:)+0.00000001)./(Year_Data($,:)+0.00000001)*100;
    end
  end
   zeit=timer();
   result=result+zeit;
end
result=result/runs;
disp('Extraction of submatrices & descriptive statistics___: "+string(result)+' sec.');


//* Misc. operation *
 
result = 0;
a=1;
for i = 1:runs
  timer();
  for x = 1:5000
    for y = 1:5000
      a=a+x+y;
    end
  end
  zeit = timer();
  result = result+zeit;
end
result = result/runs;
disp('Loop test____________________________________________: '+string(result)+' sec.');
clear('a');
clear('b');
for i = 1:runs
  b = abs(rand(3800,3800,'n')/2);
  timer();
  a = b.^1000;
  zeit = timer();
  result = result+zeit;
end
result = result/runs;
disp('3800x3800 normal distributed random matrix^1000______: '+string(result)+' sec.');
clear('a');
clear('b');
result = 0;
for i = 1:runs
  a = rand(3000000,1,'n');
  timer();
  b = -sort(-a);
  zeit = timer();
  result = result+zeit;
end
result = result/runs;
disp('3000000 values sorted ascending______________________: '+string(result)+' sec.');
 
//* Analysis *
 
clear('a');
clear('b');
result = 0;
for i = 1:runs
  a = rand(1048576,1,'n');
  timer();
  b = fft(a,-1);
  zeit = timer();
  result = result+zeit;
end
result = result/runs;
disp('FFT over 1048576 values______________________________: '+string(result)+' sec.');
 
clear('a');
result=0;
intresult=0;
x=[-%pi,%pi,%pi;%pi,%pi,-%pi;-%pi,-%pi,-%pi;-%pi,-%pi,-%pi];
y=[-%pi,-%pi,-%pi;-%pi,-%pi,%pi;%pi,-%pi,-%pi;-%pi,%pi,%pi];
z=[-%pi,-%pi,%pi;-%pi,%pi,%pi;-%pi,%pi,%pi;%pi,-%pi,-%pi];
deff('v1=f1(xyz,numfun)','v1=sin(xyz''*xyz)')
for i=1:runs
   timer();
   [X,Y,Z]=cube2tetrahedrons()
   [intresult,err]=int3d(X*%pi,Y*%pi,Z*%pi,myf,6,[0,1000000,1.d-1,1.d-4])
   zeit=timer();
   result=result+zeit;
end
result=result/runs;
disp('Triple integration___________________________________ : '+string(result)+' sec.')
 
//* Algebra *
 
clear('a');
clear('b');
result = 0;
for i = 1:runs
  a = rand(1000,1000,'u');
  timer();
  b = det(a);
  zeit = timer();
  result = result+zeit;
end
result = result/runs;
disp('Determinant of a 1000x1000 random matrix_____________: '+string(result)+' sec.');
clear('a');
clear('b');
result = 0;
for i = 1:runs
  a = rand(1000,1000,'u');
  timer();
  b = inv(a);
  zeit = timer();
  result = result+zeit;
end
result = result/runs;
disp('Inverse of a 1000x1000 uniform distr. random matrix__: '+string(result)+' sec.');
clear('a');
clear('b');
result = 0;
for i = 1:runs
  a = rand(600,600,'n');
  timer();
  c = spec(a);
  zeit = timer();
  result = result+zeit;
end
result = result/runs;
disp('Eigenval. of a normal distr. 600x600 randommatrix____: '+string(result)+' sec.');
clear('a');
clear('b');
result = 0;
for i = 1:runs
  a = rand(1000,1000,'n');
  a = a'*a;
  timer();
  b = chol(a);
  zeit = timer();
  result = result+zeit;
end
result = result/runs;
disp('Cholesky decomposition of a 1000x1000-matrix_________: '+string(result)+' sec.');
clear('a');
clear('b');
result = 0;
for i = 1:runs
  a = rand(1000,1000,'n');
  timer();
  b = a'*a;
  zeit = timer();
  result = result+zeit;
end
result = result/runs;
disp('1000x1000 cross-product matrix_______________________: '+string(result)+' sec.');
 
//* Number theory *
 
clear('a');
clear('b');
phi = 1.61803398874989;
result = 0;
for i = 1:runs
  a = floor(1000*rand(1000000,1,'u'));
  timer();
  b = (phi.^a-(-phi).^(-a))/sqrt(5);
  zeit = timer();
  result = result+zeit;
end
result = result/runs;
disp('Calculation of 1000000 fibonacci numbers______________: '+string(result)+' sec.');
 
//* Stochastic-statistic *
 
clear('a');
clear('b');
result = 0;
for i = 1:runs
  a = rand(1500,1500,'n')^2;
  timer();
  b = gamma(a(:));
  zeit = timer();
  result = result+zeit;
end
result = result/runs;
disp('Gamma function over a 1500x1500 matrix_______________: '+string(result)+' sec.');
clear('a');
clear('b');
result = 0;
for i = 1:runs
  a = rand(1500,1500,'n')^2;
  timer();
  b = erf(a(:));
  zeit = timer();
  result = result+zeit;
end
result = result/runs;
disp('Gaussian error function over a 1500x1500 matrix______: '+string(result)+' sec.');
clear('a');
clear('b');
result = 0;
for i = 1:runs
  a = rand(1000,1000,'n');
  b = 1:1000;
  timer();
  b = a\b';
  zeit = timer();
  result = result+zeit;
end
result = result/runs;
disp('Linear regression over a 1000x1000 matrix____________: '+string(result)+' sec.');